﻿Imports Infragistics.Win.UltraWinListView

Public Class frmChooseLayer
  Public Property LayerMatrixTable As DataTable
  Public Property LayerProps As New WmtsLayerProps

  Private Sub btnOK_Click(sender As Object, e As EventArgs) Handles btnOK.Click
    mSetLayerProps()
    DialogResult = DialogResult.OK
    Me.Close()
  End Sub
  Private Sub mSetLayerProps()
    If lvwLayers.SelectedItems.Count = 0 Then
      Return
    End If
    Dim oItem As UltraListViewItem = lvwLayers.SelectedItems(0)
    With LayerProps
      .LayerName = oItem.Value.ToString
      .LayerId = oItem.Key
      .Srid = mGetLayerSrid()
      .Identifier = oItem.Tag.ToString
    End With

  End Sub
  Private Function mGetLayerSrid() As String
    If cboEPSG.SelectedIndex = -1 Then
      Return String.Empty
    End If

    Dim o = cboEPSG.Items(cboEPSG.SelectedIndex)
    Return o.ToString

  End Function
  Private Sub lvwLayers_ItemSelectionChanged(sender As Object, e As ItemSelectionChangedEventArgs) Handles lvwLayers.ItemSelectionChanged
    '***** Populate the combo box with available srid
    mPopulateEpsgCombo(e.SelectedItems(0).Key.ToString)
  End Sub
  Private Sub mPopulateEpsgCombo(sLayerId As String)
    cboEPSG.DataSource = Nothing
    cboEPSG.DataSource = mGetEpsgForTable(sLayerId)
    cboEPSG.SelectedIndex = 0
  End Sub
  Private Function mGetEpsgForTable(sLayerId As String) As List(Of String)
    Dim oRow = LayerMatrixTable.Select("Layer_Id=" + sLayerId)
    Dim oSrid As New List(Of String)

    For i = 0 To oRow.Length - 1
      oSrid.Add(oRow(i)("TileMatrixSet").ToString)
    Next i

    Return oSrid
  End Function

End Class