﻿Imports System.Xml
Imports ThinkGeo.MapSuite.Layers
Imports ThinkGeo.MapSuite.Shapes
Imports ThinkGeo.MapSuite.WinForms

Public Class frmMain
  Private WithEvents moWmtsLayer As New WmtsLayer()
  Private moLayer As DataTable
  Private moLayerStyle As DataTable
  Private moTableMatrixLink As DataTable
  Private moWGS84BoundingBox As DataTable
  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    Dim oProj4 As New Proj4Projection
    Dim sUri As String = String.Empty

    'sUri = "http://geoportal.trinity.duke.edu/geoserver/gwc/service/wmts/"
    'sUri = "https://basemap.nationalmap.gov/arcgis/rest/services/USGSImageryOnly/MapServer/WMTS?/"
    'sUri = "https://basemap.nationalmap.gov/arcgis/rest/services/USGSImageryOnly/MapServer/WMTS/"
    'sUri = "https://basemap.nationalmap.gov/arcgis/rest/services/USGSShadedReliefOnly/MapServer/WMTS/"


    sUri = "https://basemap.nationalmap.gov/arcgis/rest/services/USGSTopo/MapServer/WMTS?"

    moWmtsLayer.ServerUris.Add(New Uri(sUri))
    moWmtsLayer.DrawingExceptionMode = ThinkGeo.MapSuite.Drawing.DrawingExceptionMode.DrawException
    moWmtsLayer.WmtsSeverEncodingType = ThinkGeo.MapSuite.Layers.WmtsSeverEncodingType.Restful
    moWmtsLayer.Open()

    'XmlToDataset(moWmtsLayer)
    'Dim oLayerForm As New frmChooseLayer With {.LayerMatrixTable = moTableMatrixLink}
    'Dim oItem As UltraListViewItem


    'With oLayerForm
    '  '***** Populate the listview
    '  For Each oRow As DataRow In moLayer.Rows
    '    If mLayerHasStyle(oRow("Layer_ID")) Then
    '      oItem = New UltraListViewItem(oRow("Layer_Id"))
    '      oItem.Value = oRow("Title")
    '      oItem.Tag = oRow("Identifier")
    '      .lvwLayers.Items.Add(oItem)
    '    End If
    '  Next oRow

    '  Dim eResult = .ShowDialog()
    '  If eResult = DialogResult.Cancel Then
    '    Me.Close()
    '    Return
    '  End If
    'End With

    'Dim oLayerProps = oLayerForm.LayerProps

    Dim oLayerProps As New WmtsLayerProps() With {.Identifier = "USGSTopo", .LayerId = 0, .LayerName = "USGSTopo", .Srid = "GoogleMapsCompatible"}

    mAddWmtsLayer(oLayerProps)
    WinformsMap1.Refresh()


  End Sub
  Private Sub mAddWmtsLayer(oLayerProps As WmtsLayerProps)
    With moWmtsLayer
      .ActiveLayerName = oLayerProps.Identifier
      .ActiveStyleName = "default"
      .TileMatrixSetName = oLayerProps.Srid
      '.IsVisible = False
      .UserAgent = "Silvics Solutions, LLC"
      .UpperScale = 126720
      .LowerScale = 15840
      lblMinMax.Text = "Lower Scale = " + .LowerScale.ToString() + ", Upper Scale = " + .UpperScale.ToString

    End With

    Dim oOverlay As New LayerOverlay
    WinformsMap1.MapUnit = ThinkGeo.MapSuite.GeographyUnit.Meter


    oOverlay.Layers.Add(moWmtsLayer)

    WinformsMap1.Overlays.Add(oOverlay)
    Dim oRect As New RectangleShape(8466755.57232525, 4918863.47372144, 14332212.7026385, 1699955.39053035)
    'oRect = New RectangleShape(-9707249.00086847, 3978461.06781238, -9615601.23316966, 3928624.25001453)
    'oRect = New RectangleShape(-13931965, 46494668, -7494592, 42902614)
    oRect = New RectangleShape(-9684689.58779258, 3944093.61989705, -9645943.81371529, 3922635.71148432)

    WinformsMap1.CurrentExtent = oRect

  End Sub
  Private Function mGetProjectionToGoogle() As Proj4Projection
    Dim oProj As New Proj4Projection
    oProj.InternalProjectionParametersString = Proj4Projection.GetWgs84ParametersString
    oProj.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString
    oProj.Open()
    Return oProj
  End Function
  Private Sub moWmtsLayer_SendingWebRequest(sender As Object, e As SendingWebRequestEventArgs) Handles moWmtsLayer.SendingWebRequest
    Debug.WriteLine(e.WebRequest.RequestUri.AbsoluteUri)
  End Sub
  Private Sub XmlToDataset(oWmtsLayer As WmtsLayer)
    Dim xmlFile As XmlReader
    Dim sCapabilities As String = oWmtsLayer.GetServerCapabilitiesXml()

    'Dim sFileName As String = sDataPath + "Capabilities.xml"
    'IO.File.WriteAllText(sFileName, sCapabilities)
    xmlFile = XmlReader.Create(oWmtsLayer.ServerUris(0).AbsoluteUri + "/WMTSCapabilities.xml")
    'xmlFile = XmlReader.Create(sFileName, New XmlReaderSettings())
    Dim ds As DataSet = New DataSet()
    Dim oRowData As New Text.StringBuilder
    ds.ReadXml(xmlFile)


    For Each oTable As DataTable In ds.Tables
      Debug.WriteLine(oTable.TableName)
      Select Case oTable.TableName
        Case "Layer"
          moLayer = oTable
        Case "Style"
          moLayerStyle = oTable
          'mDisplayTableContents(oTable)
        Case "TileMatrixSetLink"
          moTableMatrixLink = oTable
          'mDisplayTableContents(oTable)
        Case "WGS84BoundingBox"
          moWGS84BoundingBox = oTable
          mDisplayTableContents(oTable)
      End Select
    Next oTable
  End Sub
  Private Sub mDisplayTableContents(oTable As DataTable)
    Dim oRowData As New Text.StringBuilder
    For Each oRow As DataRow In oTable.Rows
      For Each oCol As DataColumn In oTable.Columns
        oRowData.Append(oCol.ColumnName + ": " + oRow.Item(oCol.ColumnName).ToString + " ")
      Next oCol
      Debug.WriteLine(oRowData.ToString)
      oRowData.Clear()
    Next oRow
  End Sub
  Private Function mGetStyleThing(sLayerId As String) As String()
    Dim oRow = moLayerStyle.Select("Layer_Id=" + sLayerId)
    Dim asSrid(oRow.Length) As String
    For i = 0 To oRow.Length - 1
      asSrid(i) = oRow(i)("Identifier").ToString
    Next i
    Return asSrid
  End Function
  Private Function mLayerHasStyle(sLayerId As String) As Boolean
    Dim asStyles = mGetStyleThing(sLayerId)
    For Each s In asStyles
      If Not s = String.Empty Then
        Return True
      End If
    Next
    Return False
  End Function

  Private Sub WinformsMap1_CurrentScaleChanged(sender As Object, e As CurrentScaleChangedWinformsMapEventArgs) Handles WinformsMap1.CurrentScaleChanged
    txtScale.Text = CInt(WinformsMap1.CurrentScale).ToString
  End Sub

  Private Sub btnSetScale_Click(sender As Object, e As EventArgs) Handles btnSetScale.Click
    btnSetScale.Enabled = False
    WinformsMap1.CurrentScale = CInt(txtScale.Text)
    'WinformsMap1.Refresh()
    btnSetScale.Enabled = True
  End Sub
End Class
